package pegex;

public class NamedParser implements Parser {
	public final Parser p;
	public final String name;
	
	public NamedParser(Parser _p, String _name) {
		p = _p;
		name = _name;
	}
	
	@Override
	public State<Character> parse(State<Character> st) {
		try {
			State<Character> res = p.parse(st);
			return res;
		} catch(Fail f) {
			throw st.fail(st.input.size(), name);
		}
	}
	
	
}
